### Homeland state rules

from CvPythonExtensions import *

# constants
DEFAULT_POINTS = 10

# globals
gc = CyGlobalContext()

class StateRule :
	
	def __init__( self ) :
		self.sName = ""
		self.dsiProvincePoints = {}
		self.diiEraPoints = {}
		self.diiReligionPoints = {}
		self.iPrereqStateReligion = -1
		self.diiCivPoints = {}
		
		self.sDesc = None
		self.sShortDesc = None
		self.sAdjective = None
	
	def getCiv( self ) :
		print "HOMELAND: getCiv() from StateRule %s" % ( self.sName )
		liCivs = []
		iMaxPoints = 0
		
		print "Civ Points:"
		print self.diiCivPoints
		
		for ( iCiv, iPoints ) in self.diiCivPoints.iteritems() :
			for i in range( 0, gc.getMAX_CIV_PLAYERS() ) :
				if( iCiv == gc.getPlayer( i ).getCivilizationType() ) :
					if( gc.getPlayer( i ).isEverAlive() or SDTK.sdObjectExists( 'Revolution', gc.getPlayer( i ) ) ) :
						iPoints = -1
						print "HOMELAND: Civ %d already used by player %s" % ( iCiv, gc.getPlayer( i ).getName() )
						break;
			print "HOMELAND: Points for Civ %d(%s):%d" % ( iCiv, gc.getCivilizationInfo( iCiv ).getDescription(), iPoints )
			if( iPoints > iMaxPoints ) :
				iMaxPoints = iPoints
				liCivs = list()
				liCivs.append( iCiv )
			elif( iPoints == iMaxPoints ) :
				liCivs.append( iCiv )
		
		if( len( liCivs ) == 0 ) :
			return -1
		
		print "Available Civs:"
		print liCivs
		
		return liCivs[gc.getGame().getSorenRandNum( len( liCivs ), "HOMELAND: Choose Civ" )]
	
	def getPoints( self, sProvince, iEra, diiReligionInfluence, iStateReligion = -1, iCiv = -1 ):
	
		print "HOMELAND: Calculate points for StateRule %s in %s" % ( self.sName, sProvince )
		
		#debug
		print diiReligionInfluence
		
		if( iCiv == -1 ) :
			# we're searching for a new civ type
			if( len( self.diiCivPoints ) == 0 ) :
				print "HOMELAND: StateRule %s has no CivTypes..." % ( self.sName )
				return 0
			
			bCivsAvailable = True
			for ( iLoopCiv, iPoints ) in self.diiCivPoints.iteritems() :
				for i in range( 0, gc.getMAX_CIV_PLAYERS() ) :
					if( iLoopCiv == gc.getPlayer( i ).getCivilizationType() ) :
						if( gc.getPlayer( i ).isEverAlive() or SDTK.sdObjectExists( 'Revolution', gc.getPlayer( i ) ) ) :
							bCivsAvailable = False
			
			if( not bCivsAvailable ) :
				print "HOMELAND: StateRule %s has no available CivTypes..." % ( self.sName )
				return 0
		
		# check province
		if( not sProvince in self.dsiProvincePoints ) :
			print "HOMELAND: Wrong Province..."
			return 0
		
		# check civ
		if( len( self.diiCivPoints ) > 0 and iCiv != -1 ) :
			if( not iCiv in self.diiCivPoints ) :
				print "HOMELAND: Wrong Civ..."
				return 0
		
		# check era
		if( len( self.diiEraPoints ) > 0 ) :
			if( not iEra in self.diiEraPoints ) :
				print "HOMELAND: Wrong Era..."
				return 0
		
		# check state religion
		if( self.iPrereqStateReligion != -1 ) :
			if( iStateReligion != self.iPrereqStateReligion ) :
				print "Wrong State Religion: %d, %d needed (%s)" % ( iStateReligion, self.iPrereqStateReligion, self.sName )
				return 0
		
		# calculate points
		points = 0
		
		## calculate province points
		points += self.dsiProvincePoints[sProvince]
		#debug
		print "%d points for Province (%s)" % ( self.dsiProvincePoints[sProvince], self.sName )
		
		## calculate civ points
		if( len( self.diiCivPoints ) > 0 and  iCiv != -1 ) :
			points += self.diiCivPoints[iCiv]
			#debug
			print "%d points for Civ (%s)" % ( self.diiCivPoints[iCiv], self.sName )
		
		## calculate era points
		if( len( self.diiEraPoints ) > 0 ) :
			points += self.diiEraPoints[iEra]
			#debug
			print "%d points for Era (%s)" % ( self.dsiProvincePoints[sProvince], self.sName )
		
		## calculate religion points
		for ( iRel, iVal ) in diiReligionInfluence.iteritems() :
			if iRel in self.diiReligionPoints :
				points += self.diiReligionPoints[iRel] * iVal
				#debug
				print "%d points for Religion (%s)" % ( self.diiReligionPoints[iRel] * iVal, self.sName )
		
		return points
	
	
	def prnt( self ) :
		print "StateRule: %s" % ( self.sName )
		for ( key, value ) in self.dsiProvincePoints.iteritems() :
			print "\tProvince: %s(%d)" % ( key, value )
		for ( key, value ) in self.diiEraPoints.iteritems() :
			print "\tEra: %d(%d)" % ( key, value )
		for ( key, value ) in self.diiReligionPoints.iteritems() :
			print "\tReligion: %d(%d)" % ( key, value )
		for ( key, value ) in self.diiCivPoints.iteritems() :
			print "\tCiv: %d(%d)" % ( key, value )
		if( self.iPrereqStateReligion != -1 ) :
			print "\tPrereq State Religion: %d" % ( self.iPrereqStateReligion )
