import xmllib
from CvPythonExtensions import *
from decimal import Decimal
from StateRules import *

#globals
gc = CyGlobalContext()

class StateRuleParser(xmllib.XMLParser):
	def __init__( self ):
		xmllib.XMLParser.__init__(self)
		self.lpResult = []

	def handle_data( self, data ):
		'do nothing'

	def start_stateRules( self, attrs ):
		print "start_stateRules"

	def end_stateRules( self ):
		print "end_stateRules"

	def start_stateRule( self, attrs ):
		print "\tstart_stateRule"
		self.lpResult.append( StateRule() )
		if( "name" in attrs ) :
			self.lpResult[len( self.lpResult ) - 1].sName = attrs["name"]
		if( "prereqStateReligion" in attrs ) :
			self.lpResult[len( self.lpResult ) - 1].iPrereqStateReligion = gc.getInfoTypeForString( attrs["prereqStateReligion"] )

	def end_stateRule( self ):
		print "\tend_stateRule"
	
	def start_description( self, attrs ):
		print "\t\tstart_description"
		if( "desc" in attrs ) :
			self.lpResult[len( self.lpResult ) - 1].sDesc = attrs["desc"]
		if( "shortDesc" in attrs ) :
			self.lpResult[len( self.lpResult ) - 1].sShortDesc = attrs["shortDesc"]
		if( "adj" in attrs ) :
			self.lpResult[len( self.lpResult ) - 1].sAdjective = attrs["adj"]

	def end_description( self ):
		print "\t\tend_description"
	
	def start_province( self, attrs ):
		print "\t\tstart_province"
		sName = attrs["name"]
		if( "points" in attrs ) :
			iPoints = Decimal( attrs["points"] )
		else :
			iPoints = DEFAULT_POINTS
		self.lpResult[len( self.lpResult ) - 1].dsiProvincePoints[sName] = iPoints

	def end_province( self ):
		print "\t\tend_province"
	
	def start_era( self, attrs ):
		print "\t\tstart_era"
		iName = gc.getInfoTypeForString( attrs["name"] )
		if( "points" in attrs ) :
			iPoints = Decimal( attrs["points"] )
		else :
			iPoints = DEFAULT_POINTS
		self.lpResult[len( self.lpResult ) - 1].diiEraPoints[iName] = iPoints

	def end_era( self ):
		print "\t\tend_era"
	
	def start_religion( self, attrs ):
		print "\t\tstart_religion"
		iName = gc.getInfoTypeForString( attrs["name"] )
		if( "points" in attrs ) :
			iPoints = Decimal( attrs["points"] )
		else :
			iPoints = DEFAULT_POINTS
		self.lpResult[len( self.lpResult ) - 1].diiReligionPoints[iName] = iPoints

	def end_religion( self ):
		print "\t\tend_religion"
	
	def start_civ( self, attrs ):
		print "\t\tstart_civ"
		iName = gc.getInfoTypeForString( attrs["name"] )
		if( "points" in attrs ) :
			iPoints = Decimal( attrs["points"] )
		else :
			iPoints = DEFAULT_POINTS
		self.lpResult[len( self.lpResult ) - 1].diiCivPoints[iName] = iPoints

	def end_civ( self ):
		print "\t\tend_civ"

def readStateRules( lsFilenames ):
	lpResult = []
	for sFilename in lsFilenames :
		filehandle = open( sFilename  )
		data = filehandle.read()
		filehandle.close()
		
		parser = StateRuleParser()
		parser.feed(data)
		lpResult.extend( parser.lpResult )
		parser.close()
	return lpResult